Hex Artifact Content

Artifact 4cb097f70384675cc54a748d538c0b227bf9b9f1:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 70 6b 67 3d 22 24 28 65 63 68  bash..pkg="$(ech
0020: 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73 40  o "$1" | sed 's@
0030: 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40 40  /*$@@;s@^\.*/*@@
0040: 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24 7b  ')"..if [ -z "${
0050: 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65  pkg}" ]; then..e
0060: 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69 6c  cho "Usage: buil
0070: 64 20 3c 70 61 63 6b 61 67 65 3e 22 20 32 3e 26  d <package>" 2>&
0080: 31 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 66  1...exit 1.fi..f
0090: 75 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e  unction determin
00a0: 65 4f 73 41 72 63 68 28 29 20 7b 0a 09 6f 73 3d  eOsArch() {..os=
00b0: 22 24 28 75 6e 61 6d 65 20 2d 73 20 7c 20 64 64  "$(uname -s | dd
00c0: 20 63 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64   conv=lcase 2>/d
00d0: 65 76 2f 6e 75 6c 6c 29 22 0a 09 61 72 63 68 3d  ev/null)"..arch=
00e0: 22 24 28 75 6e 61 6d 65 20 2d 6d 20 7c 20 64 64  "$(uname -m | dd
00f0: 20 63 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64   conv=lcase 2>/d
0100: 65 76 2f 6e 75 6c 6c 29 22 0a 0a 09 63 61 73 65  ev/null)"...case
0110: 20 22 24 7b 61 72 63 68 7d 22 20 69 6e 0a 09 09   "${arch}" in...
0120: 69 3f 38 36 29 0a 09 09 09 61 72 63 68 3d 27 69  i?86)....arch='i
0130: 78 38 36 27 0a 09 09 09 3b 3b 0a 09 65 73 61 63  x86'....;;..esac
0140: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74  .}..function det
0150: 65 72 6d 69 6e 65 50 72 65 66 69 78 28 29 20 7b  erminePrefix() {
0160: 0a 09 64 65 74 65 72 6d 69 6e 65 4f 73 41 72 63  ..determineOsArc
0170: 68 0a 0a 09 70 72 65 66 69 78 73 75 66 66 69 78  h...prefixsuffix
0180: 3d 22 24 7b 70 6b 67 7d 2f 24 7b 6f 73 7d 2d 24  ="${pkg}/${os}-$
0190: 7b 61 72 63 68 7d 2f 24 7b 76 65 72 73 69 6f 6e  {arch}/${version
01a0: 7d 22 0a 09 70 72 65 66 69 78 3d 22 2f 6f 70 74  }"..prefix="/opt
01b0: 2f 61 70 70 66 73 2f 24 7b 64 6f 6d 61 69 6e 7d  /appfs/${domain}
01c0: 2f 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d  /${prefixsuffix}
01d0: 22 0a 09 64 65 73 74 64 69 72 3d 22 24 28 70 77  "..destdir="$(pw
01e0: 64 29 2f 49 4e 53 54 22 0a 0a 09 6d 6b 64 69 72  d)/INST"...mkdir
01f0: 20 22 24 7b 64 65 73 74 64 69 72 7d 22 20 7c 7c   "${destdir}" ||
0200: 20 64 69 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e   die.}..function
0210: 20 70 72 65 63 6f 6e 66 69 67 75 72 65 28 29 20   preconfigure() 
0220: 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  {..:.}..function
0230: 20 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 28 29   postconfigure()
0240: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
0250: 6e 20 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a  n configure() {.
0260: 09 67 6c 69 62 63 76 65 72 73 3d 32 2e 32 30 0a  .glibcvers=2.20.
0270: 09 67 6c 69 62 63 64 69 72 3d 22 2f 6f 70 74 2f  .glibcdir="/opt/
0280: 61 70 70 66 73 2f 63 6f 72 65 2e 61 70 70 66 73  appfs/core.appfs
0290: 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f 67 6c 69 62  .rkeene.org/glib
02a0: 63 2f 70 6c 61 74 66 6f 72 6d 2f 24 7b 67 6c 69  c/platform/${gli
02b0: 62 63 76 65 72 73 7d 22 0a 09 64 79 6e 6c 69 6e  bcvers}"..dynlin
02c0: 6b 65 72 3d 22 24 28 6c 73 20 22 24 7b 67 6c 69  ker="$(ls "${gli
02d0: 62 63 64 69 72 7d 22 2f 6c 69 62 2f 6c 64 2d 6c  bcdir}"/lib/ld-l
02e0: 69 6e 75 78 2a 2e 73 6f 2e 2a 20 7c 20 74 61 69  inux*.so.* | tai
02f0: 6c 20 2d 6e 20 31 29 22 0a 0a 09 43 46 4c 41 47  l -n 1)"...CFLAG
0300: 53 3d 22 2d 49 24 7b 67 6c 69 62 63 64 69 72 7d  S="-I${glibcdir}
0310: 2f 69 6e 63 6c 75 64 65 22 0a 09 43 50 50 46 4c  /include"..CPPFL
0320: 41 47 53 3d 22 2d 49 24 7b 67 6c 69 62 63 64 69  AGS="-I${glibcdi
0330: 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 4c 44 46  r}/include"..LDF
0340: 4c 41 47 53 3d 22 2d 57 6c 2c 2d 2d 72 70 61 74  LAGS="-Wl,--rpat
0350: 68 2c 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69  h,${glibcdir}/li
0360: 62 20 2d 57 6c 2c 2d 2d 64 79 6e 61 6d 69 63 2d  b -Wl,--dynamic-
0370: 6c 69 6e 6b 65 72 2c 24 7b 64 79 6e 6c 69 6e 6b  linker,${dynlink
0380: 65 72 7d 22 0a 09 65 78 70 6f 72 74 20 43 46 4c  er}"..export CFL
0390: 41 47 53 20 43 50 50 46 4c 41 47 53 20 4c 44 46  AGS CPPFLAGS LDF
03a0: 4c 41 47 53 0a 0a 09 2e 2f 63 6f 6e 66 69 67 75  LAGS..../configu
03b0: 72 65 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 70  re --prefix="${p
03c0: 72 65 66 69 78 7d 22 20 2d 2d 73 79 73 63 6f 6e  refix}" --syscon
03d0: 66 64 69 72 3d 2f 65 74 63 20 2d 2d 6c 6f 63 61  fdir=/etc --loca
03e0: 6c 73 74 61 74 65 64 69 72 3d 2f 76 61 72 0a 7d  lstatedir=/var.}
03f0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 62 75  ..function prebu
0400: 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  ild() {..:.}..fu
0410: 6e 63 74 69 6f 6e 20 70 6f 73 74 62 75 69 6c 64  nction postbuild
0420: 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74  () {..:.}..funct
0430: 69 6f 6e 20 62 75 69 6c 64 28 29 20 7b 0a 09 67  ion build() {..g
0440: 72 65 70 20 22 44 45 53 54 44 49 52 22 20 4d 61  rep "DESTDIR" Ma
0450: 6b 65 66 69 6c 65 20 7c 7c 20 64 69 65 20 22 44  kefile || die "D
0460: 6f 6e 27 74 20 6b 6e 6f 77 20 68 6f 77 20 74 6f  on't know how to
0470: 20 62 75 69 6c 64 20 74 68 69 73 20 73 6f 66 74   build this soft
0480: 77 61 72 65 22 0a 0a 09 6d 61 6b 65 0a 7d 0a 0a  ware"...make.}..
0490: 66 75 6e 63 74 69 6f 6e 20 70 72 65 69 6e 73 74  function preinst
04a0: 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  all() {..:.}..fu
04b0: 6e 63 74 69 6f 6e 20 70 6f 73 74 69 6e 73 74 61  nction postinsta
04c0: 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e  ll() {..:.}..fun
04d0: 63 74 69 6f 6e 20 69 6e 73 74 61 6c 6c 28 29 20  ction install() 
04e0: 7b 0a 09 6d 61 6b 65 20 69 6e 73 74 61 6c 6c 20  {..make install 
04f0: 44 45 53 54 44 49 52 3d 22 24 7b 64 65 73 74 64  DESTDIR="${destd
0500: 69 72 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  ir}".}..function
0510: 20 63 6c 65 61 6e 75 70 28 29 20 7b 0a 09 63 64   cleanup() {..cd
0520: 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c   "${workdir}" ||
0530: 20 65 78 69 74 20 31 0a 09 63 64 20 2e 2e 20 7c   exit 1..cd .. |
0540: 7c 20 65 78 69 74 20 31 0a 09 72 6d 20 2d 72 66  | exit 1..rm -rf
0550: 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 0a 7d 0a   "${workdir}".}.
0560: 0a 66 75 6e 63 74 69 6f 6e 20 64 69 65 28 29 20  .function die() 
0570: 7b 0a 09 6c 6f 63 61 6c 20 6d 65 73 73 61 67 65  {..local message
0580: 0a 0a 09 6d 65 73 73 61 67 65 3d 22 24 31 22 0a  ...message="$1".
0590: 0a 09 69 66 20 5b 20 2d 6e 20 22 24 7b 6d 65 73  ..if [ -n "${mes
05a0: 73 61 67 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  sage}" ]; then..
05b0: 09 65 63 68 6f 20 22 65 72 72 6f 72 3a 20 24 7b  .echo "error: ${
05c0: 6d 65 73 73 61 67 65 7d 22 20 3e 26 32 0a 09 66  message}" >&2..f
05d0: 69 0a 0a 09 63 6c 65 61 6e 75 70 0a 0a 09 65 78  i...cleanup...ex
05e0: 69 74 20 31 0a 7d 0a 0a 63 64 20 22 24 28 64 69  it 1.}..cd "$(di
05f0: 72 6e 61 6d 65 20 22 24 28 77 68 69 63 68 20 22  rname "$(which "
0600: 24 30 22 29 22 29 22 20 7c 7c 20 65 78 69 74 20  $0")")" || exit 
0610: 31 0a 0a 69 66 20 5b 20 2d 66 20 27 62 75 69 6c  1..if [ -f 'buil
0620: 64 2e 63 6f 6e 66 27 20 5d 3b 20 74 68 65 6e 0a  d.conf' ]; then.
0630: 09 2e 20 27 62 75 69 6c 64 2e 63 6f 6e 66 27 0a  .. 'build.conf'.
0640: 66 69 0a 0a 69 66 20 5b 20 2d 64 20 22 70 6b 67  fi..if [ -d "pkg
0650: 73 2f 24 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65  s/${pkg}" ]; the
0660: 6e 0a 09 70 6b 67 64 69 72 3d 22 70 6b 67 73 2f  n..pkgdir="pkgs/
0670: 24 7b 70 6b 67 7d 22 0a 09 70 6b 67 66 69 6c 65  ${pkg}"..pkgfile
0680: 3d 22 24 7b 70 6b 67 64 69 72 7d 2f 69 6e 66 6f  ="${pkgdir}/info
0690: 22 0a 65 6c 73 65 0a 09 70 6b 67 66 69 6c 65 3d  ".else..pkgfile=
06a0: 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70  "pkgs/${pkg}"..p
06b0: 6b 67 64 69 72 3d 22 24 7b 70 6b 67 66 69 6c 65  kgdir="${pkgfile
06c0: 7d 22 0a 66 69 0a 0a 69 66 20 5b 20 21 20 2d 65  }".fi..if [ ! -e
06d0: 20 22 24 7b 70 6b 67 66 69 6c 65 7d 22 20 5d 3b   "${pkgfile}" ];
06e0: 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 49 6e 76   then..echo "Inv
06f0: 61 6c 69 64 20 70 61 63 6b 61 67 65 2e 22 20 3e  alid package." >
0700: 26 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a  &2...exit 1.fi..
0710: 70 6b 67 64 61 74 65 3d 22 24 28 66 69 6e 64 20  pkgdate="$(find 
0720: 22 24 7b 70 6b 67 64 69 72 7d 22 20 2d 74 79 70  "${pkgdir}" -typ
0730: 65 20 66 20 2d 70 72 69 6e 74 66 20 27 25 54 59  e f -printf '%TY
0740: 25 54 6d 25 54 64 25 54 48 25 54 4d 2e 25 54 53  %Tm%Td%TH%TM.%TS
0750: 5c 6e 27 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20  \n' 2>/dev/null 
0760: 7c 20 63 75 74 20 2d 66 20 31 2d 32 20 2d 64 20  | cut -f 1-2 -d 
0770: 27 2e 27 20 7c 20 73 6f 72 74 20 2d 6e 20 7c 20  '.' | sort -n | 
0780: 74 61 69 6c 20 2d 6e 20 31 29 22 0a 0a 2e 20 22  tail -n 1)"... "
0790: 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 0a 61 72 63  ${pkgfile}"..arc
07a0: 68 69 76 65 64 69 72 3d 22 24 28 70 77 64 29 2f  hivedir="$(pwd)/
07b0: 41 52 43 48 49 56 45 22 0a 77 6f 72 6b 64 69 72  ARCHIVE".workdir
07c0: 3d 22 77 6f 72 6b 64 69 72 2d 24 24 24 7b 52 41  ="workdir-$$${RA
07d0: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  NDOM}${RANDOM}${
07e0: 52 41 4e 44 4f 4d 7d 22 0a 73 72 63 66 69 6c 65  RANDOM}".srcfile
07f0: 3d 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d 2f  ="${archivedir}/
0800: 24 7b 70 6b 67 7d 22 0a 6d 6b 64 69 72 20 22 24  ${pkg}".mkdir "$
0810: 7b 61 72 63 68 69 76 65 64 69 72 7d 22 20 3e 2f  {archivedir}" >/
0820: 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f  dev/null 2>/dev/
0830: 6e 75 6c 6c 0a 6d 6b 64 69 72 20 22 24 7b 77 6f  null.mkdir "${wo
0840: 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20  rkdir}" || exit 
0850: 31 0a 63 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d  1.cd "${workdir}
0860: 22 20 7c 7c 20 65 78 69 74 20 31 0a 77 6f 72 6b  " || exit 1.work
0870: 64 69 72 3d 22 24 28 70 77 64 29 22 0a 0a 69 66  dir="$(pwd)"..if
0880: 20 5b 20 21 20 2d 65 20 22 24 7b 73 72 63 66 69   [ ! -e "${srcfi
0890: 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 23 20  le}" ]; then..# 
08a0: 44 6f 77 6e 6c 6f 61 64 0a 09 23 23 20 43 6c 65  Download..## Cle
08b0: 61 6e 75 70 0a 09 72 6d 20 2d 66 20 73 72 63 2e  anup..rm -f src.
08c0: 6e 65 77 20 73 72 63 0a 0a 09 23 23 20 46 65 74  new src...## Fet
08d0: 63 68 20 66 69 6c 65 0a 09 77 67 65 74 20 2d 4f  ch file..wget -O
08e0: 20 73 72 63 2e 6e 65 77 20 22 24 7b 75 72 6c 7d   src.new "${url}
08f0: 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 23 23  " || exit 1...##
0900: 20 56 65 72 69 66 79 20 73 69 67 6e 61 74 75 72   Verify signatur
0910: 65 0a 09 73 72 63 5f 73 68 61 32 35 36 3d 22 24  e..src_sha256="$
0920: 28 6f 70 65 6e 73 73 6c 20 73 68 61 32 35 36 20  (openssl sha256 
0930: 27 73 72 63 2e 6e 65 77 27 20 7c 20 73 65 64 20  'src.new' | sed 
0940: 27 73 40 5e 2e 2a 3d 20 40 40 27 29 22 0a 09 69  's@^.*= @@')"..i
0950: 66 20 5b 20 22 24 7b 73 72 63 5f 73 68 61 32 35  f [ "${src_sha25
0960: 36 7d 22 20 21 3d 20 22 24 7b 73 68 61 32 35 36  6}" != "${sha256
0970: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68  }" ]; then...ech
0980: 6f 20 22 53 48 41 32 35 36 20 6d 69 73 6d 61 74  o "SHA256 mismat
0990: 63 68 3a 20 20 44 6f 77 6e 6c 6f 61 64 65 64 3a  ch:  Downloaded:
09a0: 20 24 7b 73 72 63 5f 73 68 61 32 35 36 7d 20 21   ${src_sha256} !
09b0: 3d 20 45 78 70 65 63 74 65 64 3a 20 24 7b 73 68  = Expected: ${sh
09c0: 61 32 35 36 7d 22 20 3e 26 32 0a 0a 09 09 65 78  a256}" >&2....ex
09d0: 69 74 20 31 0a 09 66 69 0a 0a 09 23 23 20 4d 6f  it 1..fi...## Mo
09e0: 76 65 20 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61  ve file into pla
09f0: 63 65 0a 09 6d 76 20 73 72 63 2e 6e 65 77 20 22  ce..mv src.new "
0a00: 24 7b 61 72 63 68 69 76 65 64 69 72 7d 2f 24 7b  ${archivedir}/${
0a10: 70 6b 67 7d 22 0a 66 69 0a 0a 23 20 44 65 63 6f  pkg}".fi..# Deco
0a20: 6d 70 72 65 73 73 20 61 72 63 68 69 76 65 0a 23  mpress archive.#
0a30: 23 20 44 65 74 65 72 6d 69 6e 65 20 74 79 70 65  # Determine type
0a40: 20 6f 66 20 61 72 63 68 69 76 65 0a 63 61 73 65   of archive.case
0a50: 20 22 24 7b 75 72 6c 7d 22 20 69 6e 0a 09 2a 2e   "${url}" in..*.
0a60: 74 61 72 2e 78 7a 7c 2a 2e 74 61 72 2e 78 7a 27  tar.xz|*.tar.xz'
0a70: 3f 27 2a 7c 2a 2e 74 78 7a 29 0a 09 09 64 65 63  ?'*|*.txz)...dec
0a80: 6f 6d 70 72 65 73 73 3d 27 78 7a 27 0a 09 09 3b  ompress='xz'...;
0a90: 3b 0a 09 2a 2e 74 61 72 2e 67 7a 7c 2a 2e 74 61  ;..*.tar.gz|*.ta
0aa0: 72 2e 67 7a 27 3f 27 2a 7c 2a 2e 74 67 7a 29 0a  r.gz'?'*|*.tgz).
0ab0: 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27 67 7a  ..decompress='gz
0ac0: 69 70 27 0a 09 09 3b 3b 0a 09 2a 2e 74 61 72 2e  ip'...;;..*.tar.
0ad0: 62 7a 32 7c 2a 2e 74 61 72 2e 62 7a 32 27 3f 27  bz2|*.tar.bz2'?'
0ae0: 2a 7c 2a 2e 74 62 7a 32 29 0a 09 09 64 65 63 6f  *|*.tbz2)...deco
0af0: 6d 70 72 65 73 73 3d 27 62 7a 69 70 32 27 0a 09  mpress='bzip2'..
0b00: 09 3b 3b 0a 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70  .;;..*.zip|*.zip
0b10: 27 3f 27 2a 29 0a 09 09 64 65 63 6f 6d 70 72 65  '?'*)...decompre
0b20: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 3b 3b 0a  ss='unzip'...;;.
0b30: 09 2a 29 0a 09 09 65 63 68 6f 20 22 55 6e 6b 6e  .*)...echo "Unkn
0b40: 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69 6f 6e 20  own compression 
0b50: 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c 7d 22 20  method: ${url}" 
0b60: 3e 26 32 0a 0a 09 09 65 78 69 74 20 31 0a 09 09  >&2....exit 1...
0b70: 3b 3b 0a 65 73 61 63 0a 0a 23 23 20 44 6f 20 64  ;;.esac..## Do d
0b80: 65 63 6f 6d 70 72 65 73 73 69 6f 6e 0a 63 61 73  ecompression.cas
0b90: 65 20 22 24 7b 64 65 63 6f 6d 70 72 65 73 73 7d  e "${decompress}
0ba0: 22 20 69 6e 0a 09 75 6e 7a 69 70 29 0a 09 09 75  " in..unzip)...u
0bb0: 6e 7a 69 70 20 22 24 7b 73 72 63 66 69 6c 65 7d  nzip "${srcfile}
0bc0: 22 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c 65  " || die 'Unable
0bd0: 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20 61   to uncompress a
0be0: 72 63 68 69 76 65 27 0a 09 09 3b 3b 0a 09 2a 29  rchive'...;;..*)
0bf0: 0a 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0c00: 7d 22 20 2d 64 63 20 22 24 7b 73 72 63 66 69 6c  }" -dc "${srcfil
0c10: 65 7d 22 20 7c 20 74 61 72 20 2d 78 66 20 2d 20  e}" | tar -xf - 
0c20: 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74  || die 'Unable t
0c30: 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63  o uncompress arc
0c40: 68 69 76 65 27 0a 09 09 3b 3b 0a 65 73 61 63 0a  hive'...;;.esac.
0c50: 0a 23 23 20 43 6c 65 61 6e 75 70 20 73 6f 75 72  .## Cleanup sour
0c60: 63 65 0a 72 6d 20 2d 66 20 73 72 63 0a 0a 23 20  ce.rm -f src..# 
0c70: 49 66 20 77 65 20 6a 75 73 74 20 68 61 76 65 20  If we just have 
0c80: 6f 6e 65 20 64 69 72 65 63 74 6f 72 79 2c 20 75  one directory, u
0c90: 73 65 20 74 68 61 74 20 64 69 72 65 63 74 6f 72  se that director
0ca0: 79 0a 64 69 72 3d 22 24 28 65 63 68 6f 20 2a 29  y.dir="$(echo *)
0cb0: 22 0a 69 66 20 5b 20 2d 65 20 22 24 7b 64 69 72  ".if [ -e "${dir
0cc0: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d 76 20 22  }" ]; then..mv "
0cd0: 24 7b 64 69 72 7d 22 2f 2a 20 2e 0a 66 69 0a 0a  ${dir}"/* ..fi..
0ce0: 23 20 53 74 61 72 74 20 6c 6f 67 67 69 6e 67 0a  # Start logging.
0cf0: 73 65 74 20 2d 78 0a 0a 23 20 44 65 74 65 72 6d  set -x..# Determ
0d00: 69 6e 65 20 70 72 6f 70 65 72 74 69 65 73 0a 64  ine properties.d
0d10: 65 74 65 72 6d 69 6e 65 50 72 65 66 69 78 0a 0a  eterminePrefix..
0d20: 23 20 53 74 61 72 74 20 74 68 65 20 62 75 69 6c  # Start the buil
0d30: 64 0a 70 72 65 63 6f 6e 66 69 67 75 72 65 20 7c  d.preconfigure |
0d40: 7c 20 64 69 65 20 27 70 72 65 63 6f 6e 66 69 67  | die 'preconfig
0d50: 75 72 65 20 66 61 69 6c 65 64 27 0a 63 6f 6e 66  ure failed'.conf
0d60: 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27 63 6f  igure || die 'co
0d70: 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a  nfigure failed'.
0d80: 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 20 7c 7c  postconfigure ||
0d90: 20 64 69 65 20 27 70 6f 73 74 63 6f 6e 66 69 67   die 'postconfig
0da0: 75 72 65 20 66 61 69 6c 65 64 27 0a 0a 70 72 65  ure failed'..pre
0db0: 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 72  build || die 'pr
0dc0: 65 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 62  ebuild failed'.b
0dd0: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 62 75 69  uild || die 'bui
0de0: 6c 64 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 62  ld failed'.postb
0df0: 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70 6f 73  uild || die 'pos
0e00: 74 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 0a  tbuild failed'..
0e10: 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  preinstall || di
0e20: 65 20 27 70 72 65 69 6e 73 74 61 6c 6c 20 66 61  e 'preinstall fa
0e30: 69 6c 65 64 27 0a 69 6e 73 74 61 6c 6c 20 7c 7c  iled'.install ||
0e40: 20 64 69 65 20 27 69 6e 73 74 61 6c 6c 20 66 61   die 'install fa
0e50: 69 6c 65 64 27 0a 70 6f 73 74 69 6e 73 74 61 6c  iled'.postinstal
0e60: 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 69 6e  l || die 'postin
0e70: 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 0a 28  stall failed'..(
0e80: 0a 09 61 70 70 64 69 72 3d 22 24 28 61 70 70 66  ..appdir="$(appf
0e90: 73 69 6e 73 74 61 6c 6c 64 69 72 29 2f 24 7b 70  sinstalldir)/${p
0ea0: 72 65 66 69 78 73 75 66 66 69 78 7d 22 0a 09 6d  refixsuffix}"..m
0eb0: 6b 64 69 72 20 2d 70 20 22 24 7b 61 70 70 64 69  kdir -p "${appdi
0ec0: 72 7d 22 0a 0a 09 63 64 20 22 24 7b 64 65 73 74  r}"...cd "${dest
0ed0: 64 69 72 7d 2f 24 7b 70 72 65 66 69 78 7d 22 20  dir}/${prefix}" 
0ee0: 7c 7c 20 65 78 69 74 20 31 0a 09 63 70 20 2d 72  || exit 1..cp -r
0ef0: 70 20 2a 20 22 24 7b 61 70 70 64 69 72 7d 22 0a  p * "${appdir}".
0f00: 09 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d  .find "${appdir}
0f10: 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67  " -print0 | xarg
0f20: 73 20 2d 30 20 74 6f 75 63 68 20 2d 74 20 22 24  s -0 touch -t "$
0f30: 7b 70 6b 67 64 61 74 65 7d 22 0a 29 0a 0a 63 6c  {pkgdate}".)..cl
0f40: 65 61 6e 75 70 0a 0a 65 78 69 74 20 30 0a        eanup..exit 0.